/**
 * @file main.c
 *
 * Basic Keil uVision project
 *
 * @author Tecnologix, 2017
 */
#include "stm32f4xx.h"                  // Device header
#include <stdint.h>
#include <stdio.h>

/* =======================================================================
 * GLOBAL VARIABLES
 * ======================================================================= */

/* My test global var */
uint32_t my_test_var = 0;

/* My test modulo var */
uint32_t my_test_even_count = 0;

/* My test global interrupt var */
uint32_t volatile my_test_intr_var = 0;

/* =======================================================================
 * EXTERNAL FUNCTIONS
 * ======================================================================= */

extern void SystemCoreClockUpdate(void);

/* =======================================================================
 * PRIVATE FUNCTIONS
 * ======================================================================= */

/* Just test function */
static void a_test_function(void)
{
	my_test_var++;
}

/* Another function */
static void another_function(uint32_t a_param)
{
	if (a_param % 2 == 0)
	{
		my_test_even_count++;
	}
}

/* =======================================================================
 * PUBLIC FUNCTIONS
 * ======================================================================= */
 
int main(void)
{
	
	/* Readout -- into SystemCoreClock -- the core clock from registers */
	SystemCoreClockUpdate();
	
	/* Enable interrupt */
	NVIC_EnableIRQ(EXTI0_IRQn);
	
	while(1)
	{
		__nop();
		
		/* A test function */
		a_test_function();
		
		/* Anoter function */
		another_function(my_test_var);
	}
}

/* =======================================================================
 * INTERRUPT HANDLER
 * ======================================================================= */

void EXTI0_IRQHandler(void)
{
	my_test_intr_var++;
}
